import { StateNode } from './index';
import { StateValue, Machine, Event } from './types';
export interface IEdge {
    event: string;
    source: StateNode;
    target: StateNode;
}
export interface INodesAndEdges {
    nodes: StateNode[];
    edges: IEdge[];
}
export declare function getNodes(node: StateNode): StateNode[];
export declare function getEdges(node: StateNode, visited?: Record<string, true>): IEdge[];
export interface Segment {
    state: StateValue;
    event: Event;
}
export interface IPathMap {
    [key: string]: Segment[];
}
export interface IPathItem {
    state: StateValue;
    path: Segment[];
}
export interface IPathsItem {
    state: StateValue;
    paths: Segment[][];
}
export interface IPathsMap {
    [key: string]: Segment[][];
}
export interface ITransitionMap {
    state: StateValue | undefined;
}
export interface IAdjacencyMap {
    [stateId: string]: Record<string, ITransitionMap>;
}
export declare function getAdjacencyMap(node: Machine): IAdjacencyMap;
export declare function getShortestPaths(machine: Machine): IPathMap;
export declare function getShortestPathsAsArray(machine: Machine): IPathItem[];
export declare function getSimplePaths(machine: Machine): IPathsMap;
export declare function getSimplePathsAsArray(machine: Machine): IPathsItem[];
